#!/sbin/sh
# 
# /system/addon.d/55-settings.sh
# During a CM10 upgrade, this script backs up:
#   dpi settings in build.prop
#   navbar settings in build.prop
#	settings for hardware keys (melfas-touchkey.kl, sec_touchkey.kl)

. /tmp/backuptool.functions

list_files() {
cat <<EOF
usr/keylayout/sec_touchkey.kl
usr/keylayout/melfas-touchkey.kl
EOF
}

case "$1" in
  backup)
    # backup files
    list_files | while read FILE DUMMY; do
      backup_file $S/"$FILE"
    done
    # backup build.prop entries  
  grep "ro.sf.lcd_density" /system/build.prop > /tmp/dpi.txt
  grep "qemu.hw.mainkeys" /system/build.prop > /tmp/keys.txt
  ;;
  restore)
    # restore files
    list_files | while read FILE REPLACEMENT; do
      R=""
      [ -n "$REPLACEMENT" ] && R="$S/$REPLACEMENT"
      [ -f "$C/$S/$FILE" ] && restore_file $S/"$FILE" "$R"
    done
    
    
    # restore custom dpi settings to build.prop
    read dpi < /tmp/dpi.txt
  	if [ ! -z "$dpi" ]
	then
		sed -i 's/ro.sf.lcd_density=.*/'$dpi/g /system/build.prop
	fi    
        
    # restore nav bar settings to build.prop
	read keys < /tmp/keys.txt
	if [ ! -z "$keys" ]
	then
		grep "qemu.hw.mainkeys" /system/build.prop
		if [ "$?" == "0" ]
		then
			sed -i 's/qemu.hw.mainkeys=.*/'$keys/g /system/build.prop
		else
			echo $keys >> /system/build.prop
		fi
	fi
		
	# clean up. deleting temp storage files
    rm /tmp/dpi.txt
    rm /tmp/keys.txt
  ;;
  pre-backup)
    # Stub
  ;;
  post-backup)
    # Stub
  ;;
  pre-restore)
    # Stub
  ;;
  post-restore)
    # Stub
  ;;
esac
